"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    makeApiRequestFunction: function() {
        return makeApiRequestFunction;
    },
    RequestError: function() {
        return RequestError;
    },
    buildUrl: function() {
        return buildUrl;
    },
    makeBuildUrlFunction: function() {
        return makeBuildUrlFunction;
    }
});
var _handlertypes = require("../server/handler-types");
function _assert_this_initialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _construct(Parent, args, Class) {
    if (_is_native_reflect_construct()) {
        _construct = Reflect.construct;
    } else {
        _construct = function construct(Parent, args, Class) {
            var a = [
                null
            ];
            a.push.apply(a, args);
            var Constructor = Function.bind.apply(Parent, a);
            var instance = new Constructor();
            if (Class) _set_prototype_of(instance, Class.prototype);
            return instance;
        };
    }
    return _construct.apply(null, arguments);
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _is_native_function(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = _object_without_properties_loose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _possible_constructor_return(self, call) {
    if (call && (_type_of(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _wrap_native_super(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;
    _wrap_native_super = function wrapNativeSuper(Class) {
        if (Class === null || !_is_native_function(Class)) return Class;
        if (typeof Class !== "function") {
            throw new TypeError("Super expression must either be null or a function");
        }
        if (typeof _cache !== "undefined") {
            if (_cache.has(Class)) return _cache.get(Class);
            _cache.set(Class, Wrapper);
        }
        function Wrapper() {
            return _construct(Class, arguments, _get_prototype_of(this).constructor);
        }
        Wrapper.prototype = Object.create(Class.prototype, {
            constructor: {
                value: Wrapper,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        return _set_prototype_of(Wrapper, Class);
    };
    return _wrap_native_super(Class);
}
function _is_native_reflect_construct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _create_super(Derived) {
    var hasNativeReflectConstruct = _is_native_reflect_construct();
    return function _createSuperInternal() {
        var Super = _get_prototype_of(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _get_prototype_of(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possible_constructor_return(this, result);
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return(g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g);
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
function makeApiRequestFunction(method) {
    var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, overrideOrigin = _ref.overrideOrigin, serverSideOrigin = _ref.serverSideOrigin;
    return function() {
        var _ref = _async_to_generator(function(route, data, options) {
            var dataAny, _ref, customOverrideOrigin, fetchOptions, query, queryStr, response, errorType, message, _$data, error, responseData, e, error1;
            return _ts_generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        dataAny = data !== null && data !== void 0 ? data : {};
                        _ref = options || {}, customOverrideOrigin = _ref.overrideOrigin, fetchOptions = _object_without_properties(_ref, [
                            "overrideOrigin"
                        ]);
                        _state.label = 1;
                    case 1:
                        _state.trys.push([
                            1,
                            6,
                            ,
                            7
                        ]);
                        query = new URLSearchParams(dataAny.query);
                        queryStr = query.toString().length > 0 ? "?" + query.toString() : "";
                        return [
                            4,
                            fetch(buildUrl(route, dataAny.params, {
                                overrideOrigin: customOverrideOrigin !== null && customOverrideOrigin !== void 0 ? customOverrideOrigin : overrideOrigin,
                                serverSideOrigin: serverSideOrigin
                            }) + queryStr, _object_spread({
                                method: method,
                                headers: {
                                    "Content-Type": "application/json",
                                    Accept: "application/json"
                                },
                                body: _handlertypes.RequestMethodHasBody[method] && dataAny.body ? JSON.stringify(dataAny.body) : undefined
                            }, fetchOptions))
                        ];
                    case 2:
                        response = _state.sent();
                        if (!!response.ok) return [
                            3,
                            4
                        ];
                        errorType = errorTypeFromCode(response.status);
                        return [
                            4,
                            response.text()
                        ];
                    case 3:
                        message = _state.sent();
                        _$data = null;
                        try {
                            _$data = JSON.parse(message);
                        } catch (e) {
                            _$data = null;
                        }
                        error = new RequestError(errorType, message, _$data);
                        throw error;
                    case 4:
                        return [
                            4,
                            response.json()
                        ];
                    case 5:
                        responseData = _state.sent();
                        return [
                            2,
                            responseData
                        ];
                    case 6:
                        e = _state.sent();
                        error1 = _instanceof(e, RequestError) ? e : new RequestError("network-error", e.message);
                        throw error1;
                    case 7:
                        return [
                            2
                        ];
                }
            });
        });
        return function(route, data, options) {
            return _ref.apply(this, arguments);
        };
    }();
}
var RequestError = /*#__PURE__*/ function(Error1) {
    "use strict";
    _inherits(RequestError, Error1);
    var _super = _create_super(RequestError);
    function RequestError(type, message, data) {
        _class_call_check(this, RequestError);
        var _this;
        var parsedJson = {
            message: undefined
        };
        try {
            parsedJson = JSON.parse(message);
        } catch (e) {
        // Empty
        }
        var _parsedJson_message;
        _this = _super.call(this, (_parsedJson_message = parsedJson.message) !== null && _parsedJson_message !== void 0 ? _parsedJson_message : message);
        _define_property(_assert_this_initialized(_this), "type", void 0);
        _define_property(_assert_this_initialized(_this), "data", void 0);
        _this.type = type;
        _this.data = data;
        return _this;
    }
    _create_class(RequestError, [
        {
            key: "toString",
            value: function toString() {
                return "RequestError[".concat(this.type, "]: ").concat(this.message);
            }
        }
    ]);
    return RequestError;
}(_wrap_native_super(Error));
function errorTypeFromCode(code) {
    if (code === 401) return "unauthorized";
    if (code === 403) return "forbidden";
    if (code === 404) return "not-found";
    if (code >= 500) return "server-error";
    if (code >= 400) return "bad-request";
    return "unknown";
}
function buildUrl(path, params) {
    var _ref = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, overrideOrigin = _ref.overrideOrigin, serverSideOrigin = _ref.serverSideOrigin;
    var parts = path.split("/");
    var url = parts.map(function(part) {
        if (part.startsWith(":")) {
            var param = part.slice(1);
            var value = params[param];
            return value;
        } else if (part.startsWith("*")) {
            var param1 = part.slice(1);
            var value1 = params[param1];
            return value1.join("/");
        } else return part;
    }).join("/");
    var baseOrigin = typeof window === "undefined" ? serverSideOrigin : window.location.origin;
    var actualOrigin = overrideOrigin !== null && overrideOrigin !== void 0 ? overrideOrigin : baseOrigin;
    var urlObj = new URL(url, actualOrigin);
    return urlObj.toString();
}
function makeBuildUrlFunction() {
    var urlOverrides = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return function(route, variables) {
        return buildUrl(route, variables, urlOverrides);
    };
}
