"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "BaseRequestHandler", {
    enumerable: true,
    get: function() {
        return BaseRequestHandler;
    }
});
var _handlertypes = require("./handler-types");
var _usefinishrequest = require("./use-finish-request");
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _assert_this_initialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _possible_constructor_return(self, call) {
    if (call && (_type_of(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _is_native_reflect_construct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _create_super(Derived) {
    var hasNativeReflectConstruct = _is_native_reflect_construct();
    return function _createSuperInternal() {
        var Super = _get_prototype_of(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _get_prototype_of(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possible_constructor_return(this, result);
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var BaseRequestHandler = /*#__PURE__*/ function(UseFinishRequest) {
    "use strict";
    _inherits(BaseRequestHandler, UseFinishRequest);
    var _super = _create_super(BaseRequestHandler);
    function BaseRequestHandler(queryParamsSchema, cookieSchema, bodySchema) {
        _class_call_check(this, BaseRequestHandler);
        var _this;
        _this = _super.call(this);
        _define_property(_assert_this_initialized(_this), "queryParamsSchema", void 0);
        _define_property(_assert_this_initialized(_this), "bodySchema", void 0);
        _define_property(_assert_this_initialized(_this), "cookieSchema", void 0);
        _this.queryParamsSchema = queryParamsSchema;
        _this.bodySchema = bodySchema;
        _this.cookieSchema = cookieSchema;
        return _this;
    }
    _create_class(BaseRequestHandler, [
        {
            key: "getBaseHandler",
            value: function getBaseHandler() {
                return this;
            }
        },
        {
            key: "getContextFunction",
            value: function getContextFunction() {
                return function() {
                    return {};
                };
            }
        },
        {
            key: "params",
            value: function params() {
                // eslint-disable-next-line @typescript-eslint/no-unused-vars
                for(var _len = arguments.length, _params = new Array(_len), _key = 0; _key < _len; _key++){
                    _params[_key] = arguments[_key];
                }
                return this;
            }
        },
        {
            key: "catchAllParams",
            value: function catchAllParams(// eslint-disable-next-line @typescript-eslint/no-unused-vars
            _segment) {
                return this;
            }
        },
        {
            key: "query",
            value: function query(schema) {
                var merged = this.queryParamsSchema.extend(schema);
                return new BaseRequestHandler(merged, this.cookieSchema, this.bodySchema);
            }
        },
        {
            key: "cookies",
            value: function cookies(schema) {
                var merged = this.cookieSchema.extend(schema);
                return new BaseRequestHandler(this.queryParamsSchema, merged, this.bodySchema);
            }
        },
        {
            key: "body",
            value: function body(schema) {
                var merged = this.bodySchema.extend(schema);
                return new BaseRequestHandler(this.queryParamsSchema, this.cookieSchema, merged);
            }
        },
        {
            key: "extend",
            value: function extend(other) {
                var mergedQ = this.queryParamsSchema.merge(other.queryParamsSchema);
                var mergedB = this.bodySchema.merge(other.bodySchema);
                var mergedC = this.cookieSchema.merge(other.cookieSchema);
                return new BaseRequestHandler(mergedQ, mergedC, mergedB);
            }
        },
        {
            key: "parseRequest",
            value: function parseRequest() {
                for(var _len = arguments.length, _tmp = new Array(_len), _key = 0; _key < _len; _key++){
                    _tmp[_key] = arguments[_key];
                }
                var _tmp1 = _sliced_to_array(_tmp, 2), req = _tmp1[0], params = _tmp1[1].params;
                var _this = this;
                return _async_to_generator(function() {
                    var query, method, hasBody, body, bodyData, cookiesObject, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step_value, key, cookie, existing, cookies;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                query = _this.queryParamsSchema.parse(Object.fromEntries(req.nextUrl.searchParams.entries()));
                                method = req.method;
                                hasBody = _handlertypes.RequestMethodHasBody[method];
                                body = {};
                                if (!hasBody) return [
                                    3,
                                    2
                                ];
                                return [
                                    4,
                                    req.json().catch(function() {
                                        return {};
                                    })
                                ];
                            case 1:
                                bodyData = _state.sent();
                                body = _this.bodySchema.parse(bodyData);
                                _state.label = 2;
                            case 2:
                                cookiesObject = {};
                                _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                                try {
                                    for(_iterator = req.cookies[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                                        _step_value = _sliced_to_array(_step.value, 2), key = _step_value[0], cookie = _step_value[1];
                                        if (cookiesObject[key]) {
                                            existing = cookiesObject[key];
                                            cookiesObject[key] = Array.isArray(existing) ? _to_consumable_array(existing).concat([
                                                cookie.value
                                            ]) : [
                                                existing,
                                                cookie.value
                                            ];
                                        } else {
                                            cookiesObject[key] = cookie.value;
                                        }
                                    }
                                } catch (err) {
                                    _didIteratorError = true;
                                    _iteratorError = err;
                                } finally{
                                    try {
                                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                                            _iterator.return();
                                        }
                                    } finally{
                                        if (_didIteratorError) {
                                            throw _iteratorError;
                                        }
                                    }
                                }
                                cookies = _this.cookieSchema.parse(cookiesObject);
                                return [
                                    2,
                                    {
                                        query: query,
                                        body: body,
                                        cookies: cookies,
                                        params: params
                                    }
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "getRequirements",
            value: function getRequirements() {
                return this;
            }
        }
    ]);
    return BaseRequestHandler;
}(_usefinishrequest.UseFinishRequest);
